Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 427938 - sys-apps/portage: emerge ignores optional build-time only dependencies when updating system
Summary: sys-apps/portage: emerge ignores optional build-time only dependencies when u...
Status: CONFIRMED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Unclassified (show other bugs)
Hardware: All Linux
: Normal normal with 1 vote (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords:
: 486550 658326 (view as bug list)
Depends on:
Blocks: 300071 598444
  Show dependency tree
 
Reported: 2012-07-24 19:30 UTC by Chris Smith
Modified: 2018-06-18 22:42 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Chris Smith 2012-07-24 19:30:17 UTC
sys-apps/portage-2.2.0_alpha120 ignores dependencies in world when updating system causing packages to have to be downgrading when updating world

Reproducible: Always

Steps to Reproduce:
1.emerge -uNDav system
2.emerge -uNDav world
3.
Actual Results:  
emerge -uNDav system
These are the packages that would be merged, in order:
Calculating dependencies... done!
[ebuild     U  ] sys-devel/bison-2.6 [2.5.1] USE="nls -static" 0 kB
Total: 1 package (1 upgrade), Size of downloads: 0 kB
Would you like to merge these packages? [Yes/No]

emerge -uNDav world
These are the packages that would be merged, in order:
Calculating dependencies... done!
Total: 0 packages, Size of downloads: 0 kB
WARNING: One or more updates have been skipped due to a dependency conflict:
sys-devel/bison:0
  (sys-devel/bison-2.6::gentoo, ebuild scheduled for merge) conflicts with
    <sys-devel/bison-2.6 required by (www-client/chromium-22.0.1215.0::gentoo, installed)
Nothing to merge; would you like to auto-clean packages?

Expected Results:  
sys-devel/bison should not get updated when system is updated because updating world just downgrades it again

emerge --info
Portage 2.2.0_alpha120 (default/linux/amd64/10.0, gcc-4.6.3, glibc-2.15-r2, 3.5.0-gentoo x86_64)
=================================================================
System uname: Linux-3.5.0-gentoo-x86_64-Intel-R-_Core-TM-_i7-2600K_CPU_@_3.40GHz-with-gentoo-2.1
Timestamp of tree: Tue, 24 Jul 2012 18:45:01 +0000
app-shells/bash:          4.2_p37
dev-java/java-config:     2.1.12
dev-lang/python:          2.7.3-r2, 3.2.3-r1
dev-util/cmake:           2.8.8-r3
dev-util/pkgconfig:       0.27
sys-apps/baselayout:      2.1-r1
sys-apps/openrc:          0.10.5
sys-apps/sandbox:         2.6
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.9.6-r3, 1.10.3, 1.11.6, 1.12.2
sys-devel/binutils:       2.22-r1
sys-devel/gcc:            4.6.3
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4.2
sys-devel/make:           3.82-r3
sys-kernel/linux-headers: 3.5 (virtual/os-headers)
sys-libs/glibc:           2.15-r2
Repositories: gentoo desktop server mythtv
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -march=native -fomit-frame-pointer -pipe -floop-interchange -floop-strip-mine -floop-block"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -march=native -fomit-frame-pointer -pipe -floop-interchange -floop-strip-mine -floop-block"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--with-bdeps y"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles news parallel-fetch parse-eapi-ebuild-head preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://mirror.netcologne.de/gentoo/ http://chi-10g-1-mirror.fastsoft.net/pub/linux/gentoo/gentoo-distfiles/ ftp://chi-10g-1-mirror.fastsoft.net/pub/linux/gentoo/gentoo-distfiles/ ftp://mirrors.rit.edu/gentoo/ ftp://gentoo.cites.uiuc.edu/pub/gentoo/"
LANG="en_US.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LINGUAS="en_US en"
MAKEOPTS="-j9"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage/desktop /usr/local/portage/server /usr/local/mythtv_portage/Gentoo"
SYNC="rsync://rsync11.us.gentoo.org/gentoo-portage"
USE="X a52 aac aalib acl acpi alsa amd64 amr apache2 audiofile bash-completion berkdb bluetooth bzip2 cairo caps cdaudio cddb cdparanoia cdr cdrdao chm cli consolekit cracklib crypt cups curl cxx dbus designer-plugin djvu dri dts dv dvb dvd dvdr ebook encode exif fam ffmpeg flac fortran gdbm gif gmp gnome gphoto2 gpm gps graphite gstreamer gtk gtk3 iconv icu ieee1394 imagemagick imap imlib ipv6 jack java jpeg jpeg2k kpathsea lame lcms libffi libnotify mad marble midi mmap mmx modules mozilla mp3 mudflap multilib musicbrainz mythtv ncurses network nls nodrm nptl nsplugin nvidia ofx ogg opencl openexr opengl openmp pam pcre pdf png policykit pulseaudio quicktime readline samba sasl scanner sdl semantic-desktop session slp smp sndfile spell sse sse2 ssl subversion svg theora threads tiff tk transparency truetype udev unicode usb v4l vcd vdpau vim-syntax vorbis vpx wav wavpack wmf x264 xattr xcomposite xine xml xorg xscreensaver xv xvid xvmc zlib" ALSA_CARDS="hda-intel hdsp hpet hrtimer rtctimer seqdummy virmidi" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump" CAMERAS="*" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en_US en" PHP_TARGETS="php5-3" PYTHON_TARGETS="python3_2 python2_7" QEMU_SOFTMMU_TARGETS="i386 x86_64" QEMU_USER_TARGETS="i386 x86_64" RUBY_TARGETS="ruby18 ruby19" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON
Comment 1 Zac Medico gentoo-dev 2012-07-25 02:36:19 UTC
The explanation is that the first command pulls in the bison-2.6 update because it traverses the dependencies in a different order. It's not an error because the <sys-devel/bison-2.6 dependency is build-time only, and therefore it's not really required unless you are going to rebuild chromium. So, it's behaving as intended, and I think we can close this bug with "WONTFIX" resolution.
Comment 2 Chris Smith 2012-07-25 02:43:16 UTC
Never ran across that problem before. It's annoying as it is but what if there were 10 or 20 such packages? And they took a long time to build?
Maybe it's the fault of the Chromium ebuild but wherever the fault lies it shouldn't work this way.

(In reply to comment #1)
> The explanation is that the first command pulls in the bison-2.6 update
> because it traverses the dependencies in a different order. It's not an
> error because the <sys-devel/bison-2.6 dependency is build-time only, and
> therefore it's not really required unless you are going to rebuild chromium.
> So, it's behaving as intended, and I think we can close this bug with
> "WONTFIX" resolution.
Comment 3 Zac Medico gentoo-dev 2012-07-25 02:57:22 UTC
(In reply to comment #2)
> Never ran across that problem before. It's annoying as it is but what if
> there were 10 or 20 such packages?

Normally, packages work with the highest available version of a given package, so it's not an issue most of the time.

> And they took a long time to build?
> Maybe it's the fault of the Chromium ebuild but wherever the fault lies it
> shouldn't work this way.

Considering how uncommon it is, I don't think it's a problem. Pretty soon, chromium will get fixed so that it works with newer bison.
Comment 4 Chris Smith 2012-07-25 03:02:07 UTC
(In reply to comment #3)
> Considering how uncommon it is, I don't think it's a problem. Pretty soon,
> chromium will get fixed so that it works with newer bison.

Isn't it up to portage to prevent such issues? Why doesn't a system update take world dependencies into consideration? Sorry - still seems like a portage flaw to me.
Comment 5 Zac Medico gentoo-dev 2012-07-25 03:09:09 UTC
Yeah, we can trigger backtracking in order to prevent the upgrade from occurring.
Comment 6 Zac Medico gentoo-dev 2014-12-28 23:13:04 UTC
*** Bug 486550 has been marked as a duplicate of this bug. ***
Comment 7 Zac Medico gentoo-dev 2018-06-18 22:42:26 UTC
*** Bug 658326 has been marked as a duplicate of this bug. ***